import { Connection } from "../connection/Connection";
import { CreateConnectionOptions } from "./CreateConnectionOptions";
import { ConnectionOptions } from "../connection/ConnectionOptions";
import { Driver } from "../driver/Driver";
/**
 * Connection manager holds all connections made to the databases and providers helper management functions
 * for all exist connections.
 */
export declare class ConnectionManager {
    private connections;
    /**
     * Creates a new connection based on the given connection options and registers a new connection in the manager.
     */
    create(options: CreateConnectionOptions): Promise<Connection>;
    /**
     * Gets registered connection with the given name. If connection name is not given then it will get a default
     * connection.
     */
    get(name?: string): Connection;
    private createDriver(driverName);
    /**
     * Creates a new connection and pushes a connection to the array.
     */
    createConnection(name: string, driver: Driver, options: ConnectionOptions): Connection;
}
