"use strict";
var NamingStrategyMetadata_1 = require("../metadata/NamingStrategyMetadata");
var index_1 = require("../index");
/**
 * Decorator registers a new naming strategy to be used in naming things.
 */
function NamingStrategy(name) {
    return function (target) {
        var strategyName = name ? name : target.name;
        index_1.defaultMetadataStorage().namingStrategyMetadatas.add(new NamingStrategyMetadata_1.NamingStrategyMetadata(target, strategyName));
    };
}
exports.NamingStrategy = NamingStrategy;
//# sourceMappingURL=NamingStrategy.js.map