"use strict";
var ColumnTypes_1 = require("../../metadata/types/ColumnTypes");
var index_1 = require("../../index");
var ColumnMetadata_1 = require("../../metadata/ColumnMetadata");
/**
 * This column will store a number - version of the entity. Every time your entity will be persisted, this number will
 * be increased by one - so you can organize visioning and update strategies of your entity.
 */
function VersionColumn(options) {
    return function (object, propertyName) {
        var reflectedType = ColumnTypes_1.ColumnTypes.typeToString(Reflect.getMetadata("design:type", object, propertyName));
        // if column options are not given then create a new empty options
        if (!options)
            options = {};
        // implicitly set a type, because this column's type cannot be anything else except date
        options.type = ColumnTypes_1.ColumnTypes.INTEGER;
        // todo: check if reflectedType is number too
        // create and register a new column metadata
        index_1.defaultMetadataStorage().columnMetadatas.add(new ColumnMetadata_1.ColumnMetadata({
            target: object.constructor,
            propertyName: propertyName,
            propertyType: reflectedType,
            mode: "version",
            options: options
        }));
    };
}
exports.VersionColumn = VersionColumn;
//# sourceMappingURL=VersionColumn.js.map