"use strict";
var index_1 = require("../../index");
var TableMetadata_1 = require("../../metadata/TableMetadata");
/**
 * This decorator is used to mark classes that will be a tables. Database schema will be created for all classes
 * decorated with it, and Repository can be retrieved and used for it.
 */
function ClosureTable(name) {
    return function (cls) {
        index_1.defaultMetadataStorage().tableMetadatas.add(new TableMetadata_1.TableMetadata(cls, name, "closure"));
    };
}
exports.ClosureTable = ClosureTable;
//# sourceMappingURL=ClosureTable.js.map