"use strict";
var index_1 = require("../../index");
var RelationMetadata_1 = require("../../metadata/RelationMetadata");
var RelationTypes_1 = require("../../metadata/types/RelationTypes");
/**
 * Marks a specific property of the class as a children of the tree.
 */
function TreeChildren(options) {
    return function (object, propertyName) {
        if (!options)
            options = {};
        var reflectedType = Reflect.getMetadata("design:type", object, propertyName);
        // add one-to-many relation for this 
        index_1.defaultMetadataStorage().relationMetadatas.add(new RelationMetadata_1.RelationMetadata({
            isTreeChildren: true,
            target: object.constructor,
            propertyName: propertyName,
            propertyType: reflectedType,
            relationType: RelationTypes_1.RelationTypes.ONE_TO_MANY,
            type: function () { return object.constructor; },
            options: options
        }));
    };
}
exports.TreeChildren = TreeChildren;
//# sourceMappingURL=TreeChildren.js.map