"use strict";
var index_1 = require("../../index");
var ColumnTypes_1 = require("../../metadata/types/ColumnTypes");
var ColumnMetadata_1 = require("../../metadata/ColumnMetadata");
/**
 * Creates a "level"/"length" column to the table that holds a closure table.
 */
function TreeLevelColumn() {
    return function (object, propertyName) {
        var reflectedType = ColumnTypes_1.ColumnTypes.typeToString(Reflect.getMetadata("design:type", object, propertyName));
        // if column options are not given then create a new empty options
        var options = {};
        // implicitly set a type, because this column's type cannot be anything else except number
        options.type = ColumnTypes_1.ColumnTypes.INTEGER;
        // create and register a new column metadata
        index_1.defaultMetadataStorage().columnMetadatas.add(new ColumnMetadata_1.ColumnMetadata({
            target: object.constructor,
            propertyName: propertyName,
            propertyType: reflectedType,
            mode: "treeLevel",
            options: options
        }));
    };
}
exports.TreeLevelColumn = TreeLevelColumn;
//# sourceMappingURL=TreeLevelColumn.js.map