import { ConnectionOptions } from "../connection/ConnectionOptions";
/**
 * Provides base functionality for all driver implementations.
 */
export declare abstract class BaseDriver {
    abstract connectionOptions: ConnectionOptions;
    protected logQuery(query: string): void;
    protected logQueryError(error: any): void;
    protected logFailedQuery(query: string): void;
    protected log(message: any, level: "log" | "debug" | "info" | "error"): void;
}
