/*!
 
 */
import { ConnectionManager } from "./connection-manager/ConnectionManager";
import { Connection } from "./connection/Connection";
import { MetadataStorage } from "./metadata-storage/MetadataStorage";
import { CreateConnectionOptions } from "./connection-manager/CreateConnectionOptions";
/**
 * Sets container to be used by TypeORM.
 *
 * @param iocContainer
 */
export declare function useContainer(iocContainer: {
    get(someClass: any): any;
}): void;
export declare function getContainer(): {
    get(someClass: any): any;
};
export declare function defaultMetadataStorage(): MetadataStorage;
/**
 * Gets a ConnectionManager which creates connections.
 */
export declare function getConnectionManager(): ConnectionManager;
/**
 * Allows to quickly create a connection based on the given options. Uses ConnectionManager.
 */
export declare function createConnection(options: CreateConnectionOptions): Promise<Connection>;
export { Connection } from "./connection/Connection";
export { ConnectionOptions } from "./connection/ConnectionOptions";
export { ConnectionManager } from "./connection-manager/ConnectionManager";
export { CreateConnectionOptions } from "./connection-manager/CreateConnectionOptions";
export { Driver } from "./driver/Driver";
export { MysqlDriver } from "./driver/MysqlDriver";
export { QueryBuilder } from "./query-builder/QueryBuilder";
export { EntityManager } from "./entity-manager/EntityManager";
export { Repository } from "./repository/Repository";
export { FindOptions } from "./repository/FindOptions";
export { InsertEvent } from "./subscriber/event/InsertEvent";
export { UpdateEvent } from "./subscriber/event/UpdateEvent";
export { RemoveEvent } from "./subscriber/event/RemoveEvent";
export { EventSubscriberInterface } from "./subscriber/EventSubscriberInterface";
