import { TargetMetadata } from "./TargetMetadata";
import { NamingStrategyInterface } from "../naming-strategy/NamingStrategyInterface";
import { EntityMetadata } from "./EntityMetadata";
import { CompositeIndexOptions } from "./options/CompositeIndexOptions";
/**
 * This metadata interface contains all information about table's composite index.
 */
export declare class CompositeIndexMetadata extends TargetMetadata {
    /**
     * Naming strategy used to generate and normalize index name.
     */
    namingStrategy: NamingStrategyInterface;
    /**
     * Entity metadata of the class to which this index is applied.
     */
    entityMetadata: EntityMetadata;
    /**
     * Indicates if this index must be unique.
     */
    readonly isUnique: boolean;
    /**
     * Composite index name.
     */
    private readonly _name;
    /**
     * Columns combination to be used as index.
     */
    private readonly _columns;
    constructor(target: Function, name: string | undefined, columns: ((object: any) => any[]) | string[], options?: CompositeIndexOptions);
    readonly name: string;
    readonly columns: string[];
}
