"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TargetMetadata_1 = require("./TargetMetadata");
/**
 * This metadata interface contains all information about table's composite index.
 */
var CompositeIndexMetadata = (function (_super) {
    __extends(CompositeIndexMetadata, _super);
    // ---------------------------------------------------------------------
    // Constructor
    // ---------------------------------------------------------------------
    function CompositeIndexMetadata(target, name, columns, options) {
        _super.call(this, target);
        this._columns = columns;
        if (name)
            this._name = name;
        if (options && options.unique)
            this.isUnique = options.unique;
    }
    Object.defineProperty(CompositeIndexMetadata.prototype, "name", {
        // ---------------------------------------------------------------------
        // Accessors
        // ---------------------------------------------------------------------
        get: function () {
            return this.namingStrategy.indexName(this.target, this._name, this.columns);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CompositeIndexMetadata.prototype, "columns", {
        get: function () {
            // if columns already an array of string then simply return it
            if (this._columns instanceof Array)
                return this._columns;
            // if columns is a function that returns array of field names then execute it and get columns names from it 
            var propertiesMap = this.entityMetadata.createPropertiesMap();
            return this._columns(propertiesMap).map(function (i) { return String(i); });
        },
        enumerable: true,
        configurable: true
    });
    return CompositeIndexMetadata;
}(TargetMetadata_1.TargetMetadata));
exports.CompositeIndexMetadata = CompositeIndexMetadata;
//# sourceMappingURL=CompositeIndexMetadata.js.map