import { PropertyMetadata } from "./PropertyMetadata";
import { NamingStrategyInterface } from "../naming-strategy/NamingStrategyInterface";
/**
 * This metadata interface contains all information about some index on a field.
 */
export declare class IndexMetadata extends PropertyMetadata {
    /**
     * Naming strategy used to generate and normalize index name.
     */
    namingStrategy: NamingStrategyInterface;
    /**
     * The name of the index.
     */
    readonly name: string;
    constructor(target: Function, propertyName: string, name?: string);
}
