import { PropertyMetadata } from "./PropertyMetadata";
import { JoinColumnOptions } from "./options/JoinColumnOptions";
import { RelationMetadata } from "./RelationMetadata";
import { ColumnMetadata } from "./ColumnMetadata";
/**
 */
export declare class JoinColumnMetadata extends PropertyMetadata {
    /**
     * Relation - owner of this join column metadata.
     */
    relation: RelationMetadata;
    /**
     * Join column name.
     */
    private readonly _name;
    /**
     * Join column referenced column name.
     */
    private readonly _referencedColumnName;
    constructor(target: Function, propertyName: string, options: JoinColumnOptions);
    /**
     * Join column name.
     */
    readonly name: string;
    /**
     * Referenced join column.
     */
    readonly referencedColumn: ColumnMetadata;
}
