"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var PropertyMetadata_1 = require("./PropertyMetadata");
/**
 */
var JoinColumnMetadata = (function (_super) {
    __extends(JoinColumnMetadata, _super);
    // ---------------------------------------------------------------------
    // Constructor
    // ---------------------------------------------------------------------
    function JoinColumnMetadata(target, propertyName, options) {
        _super.call(this, target, propertyName);
        if (options.name)
            this._name = options.name;
        if (options.referencedColumnName)
            this._referencedColumnName = options.referencedColumnName;
    }
    Object.defineProperty(JoinColumnMetadata.prototype, "name", {
        // ---------------------------------------------------------------------
        // Accessors
        // ---------------------------------------------------------------------
        /**
         * Join column name.
         */
        get: function () {
            return this.relation.entityMetadata.namingStrategy.joinColumnInverseSideName(this._name, this.relation.propertyName);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JoinColumnMetadata.prototype, "referencedColumn", {
        /**
         * Referenced join column.
         */
        get: function () {
            var _this = this;
            if (this._referencedColumnName) {
                var referencedColumn = this.relation.inverseEntityMetadata.columns.find(function (column) { return column.name === _this._referencedColumnName; });
                if (!referencedColumn)
                    throw new Error("Referenced column " + this._referencedColumnName + " was not found in entity " + this.name);
            }
            return this.relation.inverseEntityMetadata.primaryColumn;
        },
        enumerable: true,
        configurable: true
    });
    return JoinColumnMetadata;
}(PropertyMetadata_1.PropertyMetadata));
exports.JoinColumnMetadata = JoinColumnMetadata;
//# sourceMappingURL=JoinColumnMetadata.js.map