"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var PropertyMetadata_1 = require("./PropertyMetadata");
/**
 */
var JoinTableMetadata = (function (_super) {
    __extends(JoinTableMetadata, _super);
    // ---------------------------------------------------------------------
    // Constructor
    // ---------------------------------------------------------------------
    function JoinTableMetadata(target, propertyName, options) {
        _super.call(this, target, propertyName);
        if (options.name)
            this._name = options.name;
        if (options.joinColumn) {
            if (options.joinColumn.name)
                this._joinColumnName = options.joinColumn.name;
            if (options.joinColumn.referencedColumnName)
                this._joinColumnReferencedColumnName = options.joinColumn.referencedColumnName;
        }
        if (options.inverseJoinColumn) {
            if (options.inverseJoinColumn.name)
                this._inverseJoinColumnName = options.inverseJoinColumn.name;
            if (options.inverseJoinColumn.referencedColumnName)
                this._inverseJoinColumnReferencedColumnName = options.inverseJoinColumn.referencedColumnName;
        }
    }
    Object.defineProperty(JoinTableMetadata.prototype, "name", {
        // ---------------------------------------------------------------------
        // Accessors
        // ---------------------------------------------------------------------
        /**
         * Join table name.
         */
        get: function () {
            if (this._name)
                return this._name;
            return this.relation.entityMetadata.namingStrategy.joinTableName(this.relation.entityMetadata.table.name, this.relation.inverseEntityMetadata.table.name, this.relation.name, this.relation.hasInverseSide ? this.relation.inverseRelation.name : "", this.referencedColumn.name, this.inverseReferencedColumn.name);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JoinTableMetadata.prototype, "joinColumnName", {
        /**
         * Join column name.
         */
        get: function () {
            if (this._joinColumnName)
                return this._joinColumnName;
            return this.relation
                .entityMetadata
                .namingStrategy
                .joinTableColumnName(this.relation.entityMetadata.table.name, this.referencedColumn.name, this.relation.inverseEntityMetadata.table.name, this.inverseReferencedColumn.name);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JoinTableMetadata.prototype, "inverseJoinColumnName", {
        /**
         * Join column name of the inverse side.
         */
        get: function () {
            if (this._inverseJoinColumnName)
                return this._inverseJoinColumnName;
            return this.relation
                .entityMetadata
                .namingStrategy
                .joinTableInverseColumnName(this.relation.inverseEntityMetadata.table.name, this.inverseReferencedColumn.name, this.relation.entityMetadata.table.name, this.referencedColumn.name);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JoinTableMetadata.prototype, "referencedColumn", {
        /**
         * Referenced join column.
         */
        get: function () {
            var _this = this;
            if (this._joinColumnReferencedColumnName) {
                var referencedColumn = this.relation.entityMetadata.columns.find(function (column) { return column.name === _this._joinColumnReferencedColumnName; });
                if (!referencedColumn)
                    throw new Error("Referenced column " + this._joinColumnReferencedColumnName + " was not found in entity " + this.name);
                return referencedColumn;
            }
            return this.relation.entityMetadata.primaryColumn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JoinTableMetadata.prototype, "inverseReferencedColumn", {
        /**
         * Referenced join column of the inverse side.
         */
        get: function () {
            var _this = this;
            if (this._inverseJoinColumnReferencedColumnName) {
                var referencedColumn = this.relation.inverseEntityMetadata.columns.find(function (column) { return column.name === _this._inverseJoinColumnReferencedColumnName; });
                if (!referencedColumn)
                    throw new Error("Referenced column " + this._inverseJoinColumnReferencedColumnName + " was not found in entity " + this.name);
                return referencedColumn;
            }
            return this.relation.inverseEntityMetadata.primaryColumn;
        },
        enumerable: true,
        configurable: true
    });
    return JoinTableMetadata;
}(PropertyMetadata_1.PropertyMetadata));
exports.JoinTableMetadata = JoinTableMetadata;
//# sourceMappingURL=JoinTableMetadata.js.map