"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var EntityMetadataNotFound_1 = require("../error/EntityMetadataNotFound");
/**
 * Array for the entity metadatas.
 */
var EntityMetadataCollection = (function (_super) {
    __extends(EntityMetadataCollection, _super);
    function EntityMetadataCollection() {
        _super.apply(this, arguments);
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    EntityMetadataCollection.prototype.hasTarget = function (target) {
        return !!this.find(function (metadata) { return metadata.target === target; });
    };
    EntityMetadataCollection.prototype.findByTarget = function (target) {
        var metadata = this.find(function (metadata) { return metadata.target === target; });
        if (!metadata)
            throw new EntityMetadataNotFound_1.EntityMetadataNotFound(target);
        return metadata;
    };
    EntityMetadataCollection.prototype.findByName = function (name) {
        var metadata = this.find(function (metadata) { return metadata.name === name; });
        if (!metadata)
            throw new EntityMetadataNotFound_1.EntityMetadataNotFound(name);
        return metadata;
    };
    return EntityMetadataCollection;
}(Array));
exports.EntityMetadataCollection = EntityMetadataCollection;
//# sourceMappingURL=EntityMetadataCollection.js.map