"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TargetMetadataCollection_1 = require("./TargetMetadataCollection");
var PropertyMetadataCollection = (function (_super) {
    __extends(PropertyMetadataCollection, _super);
    function PropertyMetadataCollection() {
        _super.apply(this, arguments);
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    PropertyMetadataCollection.prototype.filterRepeatedMetadatas = function (existsMetadatas) {
        var collection = new this.constructor();
        this
            .filter(function (metadata) {
            return !existsMetadatas.find(function (fieldFromDocument) { return fieldFromDocument.propertyName === metadata.propertyName; });
        })
            .forEach(function (metadata) { return collection.add(metadata); });
        return collection;
    };
    PropertyMetadataCollection.prototype.findByProperty = function (propertyName) {
        return this.find(function (item) { return item.propertyName === propertyName; });
    };
    PropertyMetadataCollection.prototype.hasWithProperty = function (propertyName) {
        return !!this.findByProperty(propertyName);
    };
    return PropertyMetadataCollection;
}(TargetMetadataCollection_1.TargetMetadataCollection));
exports.PropertyMetadataCollection = PropertyMetadataCollection;
//# sourceMappingURL=PropertyMetadataCollection.js.map