"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetadataAlreadyExistsError_1 = require("../../metadata-storage/error/MetadataAlreadyExistsError");
var TargetMetadataCollection = (function (_super) {
    __extends(TargetMetadataCollection, _super);
    function TargetMetadataCollection() {
        _super.apply(this, arguments);
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    TargetMetadataCollection.prototype.filterByClass = function (cls) {
        return this.filterByClasses([cls]);
    };
    TargetMetadataCollection.prototype.filterByClasses = function (classes) {
        var collection = new this.constructor();
        this.filter(function (metadata) { return classes.indexOf(metadata.target) !== -1; })
            .forEach(function (metadata) { return collection.add(metadata); });
        return collection;
    };
    TargetMetadataCollection.prototype.add = function (metadata, checkForDuplicateTargets) {
        if (checkForDuplicateTargets === void 0) { checkForDuplicateTargets = false; }
        if (checkForDuplicateTargets && this.hasWithTarget(metadata.target))
            throw new MetadataAlreadyExistsError_1.MetadataAlreadyExistsError(metadata.constructor.name, metadata.target);
        this.push(metadata);
    };
    TargetMetadataCollection.prototype.addUniq = function (metadata) {
        if (this.hasWithTarget(metadata.target))
            throw new MetadataAlreadyExistsError_1.MetadataAlreadyExistsError(metadata.constructor.name, metadata.target);
        this.push(metadata);
    };
    // -------------------------------------------------------------------------
    // Private Methods
    // -------------------------------------------------------------------------
    TargetMetadataCollection.prototype.hasWithTarget = function (constructor) {
        return !!this.find(function (metadata) { return metadata.target === constructor; });
    };
    return TargetMetadataCollection;
}(Array));
exports.TargetMetadataCollection = TargetMetadataCollection;
//# sourceMappingURL=TargetMetadataCollection.js.map