import { NamingStrategyInterface } from "./NamingStrategyInterface";
/**
 * Naming strategy that is used by default.
 */
export declare class DefaultNamingStrategy implements NamingStrategyInterface {
    tableName(className: string): string;
    columnName(propertyName: string): string;
    relationName(propertyName: string): string;
    indexName(target: Function, name: string, columns: string[]): string;
    joinColumnInverseSideName(joinColumnName: string, propertyName: string): string;
    joinTableName(firstTableName: string, secondTableName: string, firstColumnName: string, secondColumnName: string, firstPropertyName: string, secondPropertyName: string): string;
    joinTableColumnName(tableName: string, columnName: string, secondTableName: string, secondColumnName: string): string;
    joinTableInverseColumnName(tableName: string, columnName: string, secondTableName: string, secondColumnName: string): string;
    closureJunctionTableName(tableName: string): string;
}
