import { EventSubscriberInterface } from "./EventSubscriberInterface";
import { ColumnMetadata } from "../metadata/ColumnMetadata";
import { EntityListenerMetadata } from "../metadata/EntityListenerMetadata";
import { EntityMetadataCollection } from "../metadata/collection/EntityMetadataCollection";
/**
 * Broadcaster provides a helper methods to broadcast events to the subscribers.
 */
export declare class Broadcaster {
    private entityMetadatas;
    private subscriberMetadatas;
    private entityListeners;
    constructor(entityMetadatas: EntityMetadataCollection, subscriberMetadatas: EventSubscriberInterface<any>[], entityListeners: EntityListenerMetadata[]);
    broadcastBeforeInsertEvent(entity: any): Promise<void>;
    broadcastBeforeUpdateEvent(entity: any, updatedColumns: ColumnMetadata[]): Promise<void>;
    broadcastBeforeRemoveEvent(entity: any, entityId: any): Promise<void>;
    broadcastAfterInsertEvent(entity: any): Promise<void>;
    broadcastAfterUpdateEvent(entity: any, updatedColumns: ColumnMetadata[]): Promise<void>;
    broadcastAfterRemoveEvent(entity: any, entityId: any): Promise<void>;
    broadcastLoadEvents(entity: any): Promise<void>;
    broadcastLoadEventsForAll(entities: any[]): Promise<void>;
    private isAllowedSubscribers(subscriber, cls);
}
